#################################################################################
# by sDextra 
#################################################################################
# 1110011 1000100 1100101 1111000 1110100 1110010 1100001
#################################################################################

#################################################################################
### Messenger Emulator
#################################################################################
init python:
#################################################################################
    display_aspect_ratio = 16.0 / 9.0
    yadj = ui.adjustment()
    
    messages = []
    
    message_time = False
    in_history = True
    choice_number = True
    click_to_continue = True
    under_messenger = True
    time_to_send_pm = 2.0
    time_to_send_am = 2.0
    
    typewriter = True
    typewriter_speed = 1
    typewriter_counter = 0

    interlocutor_name = "sDextra"
    interlocutor_online = True
    interlocutor_typing = True
    interlocutor_extra_time = 1
    interlocutor_typing_speed = 0.1
    interlocutor_typing_show = False
    interlocutor_sends = False

    groupchat = False
    groupchat_enable = False
    groupchat_who_typing = False
    active_groupchat = False

    audio_path = 'sfx/'
    audio_extension = '.mp3'

    def show_messenger():
        _window_hide()
        renpy.show_screen('messenger')
        renpy.pause(1.0, hard=True)
    def hide_messenger():
        renpy.hide_screen('messenger')
        renpy.pause(1.0, hard=True)
        _window_show()

    class GroupChat():
        def __init__(self, name='Chat Name'):
            self.name = name
            self.avatar = 'messenger/av/'+name.lower().replace(' ', '_')+'.png'
            self.members = 0
            self.list = []
        def add(self, interlocutor):
            self.list.append(interlocutor)
            self.members += 1
        def remove(self, name):
            for interlocutor in self.list:
                if interlocutor.name == name:
                    self.list.remove(interlocutor)
                    self.members -= 1
                    return
        def get_interlocutor(self, ID):
            for interlocutor in self.list:
                if interlocutor.id == ID:
                    return interlocutor
            return False

    class Interlocutor():
        def __init__(self, ID=1, name='Name', color='#fff'):
            self.id = ID
            self.name = name
            self.color = color
            self.avatar ='messenger/groupchat/'+name.lower().replace(' ', '_')+'.png'

    from mutagen.mp3 import MP3
    class Audio():
        def __init__(self, name, bar):
            self.file_name = name
            self.name = audio_path + self.file_name + audio_extension
            self.length = self.get_audio_length(self.name)
            self.duration = self.get_duration(self.length)
            self.bar = renpy.random.randint(1,9) if not bar else bar
        
        # get mp3 file length
        def get_audio_length(self, name):
            file = renpy.loader.transfn(name)
            audio = MP3(file)
            length = int(round(audio.info.length, 0))
            return length
        def play(self):
            renpy.play(self.name, channel='sound')
        def bar_idle(self):
            return 'messenger/audio/bar_'+str(self.bar)+'.png'
        def bar_hover(self):
            return color_brightness('messenger/audio/bar_'+str(self.bar)+'.png')
        # Audio's minutes and seconds
        def get_duration(self, d):
            m = d // 60
            m = '0'+str(m) if m < 10 else m
            s = d % 60
            s = '0'+str(s) if s < 10 and s != 0 else str(s)+'0' if s == 0 else s
            return "%s:%s"%(m,s)

    class Picture():
        def __init__(self, name, x):
            self.name = str(name)
            self.x = x # maximum 580
            self.y = int(x/display_aspect_ratio)
        # Open picture to fulll screen
        def open_fullpic(self):
            renpy.show_screen('sc_fullpic', pic=self.name)

    from datetime import datetime
    class Message():
        def __init__(self, what, who, choices, audio, audio_bar, pic, pic_x, time):
            self.what = what
            self.who = who
            self.time_list = time
            self.choices = choices
            self.position = self.find_position(who)
            self.pic = Picture(pic, pic_x) if pic else False
            self.audio = Audio(audio, audio_bar) if audio else False
            self.time = self.format_time(time) if type(message_time) != bool else self.get_current_time() if time else False
        
        def find_position(self, who):
            position = 0.0 if who else .99
            return position

        # time from 
        def get_current_time(self):
            now = datetime.now()
            time = datetime.strftime(now, "%H:%M")
            return time
            
        # Message time
        def format_time(self, time):
            h, m = time
            m = '0'+str(m) if m < 10 and m != 0 else str(m)+'0' if m == 0 else m
            h = '0'+str(h) if h < 10 and h != 0 else str(h)+'0' if h == 0 else h
            return "%s:%s"%(h,m)


    # New message
    def msg(what, who=0, choices=False, pic=False, pic_size=660, audio=False, audio_bar=0, status=False):
        if status:
            store.interlocutor_online = True if status == 'online' else interlocutor_online

        if who and what and interlocutor_typing:
            store.groupchat_who_typing = who
            store.interlocutor_typing_show = True
            renpy.pause(interlocutor_extra_time, hard=True)
            speed = len(what) * interlocutor_typing_speed
            renpy.pause(speed, hard=True)
            store.interlocutor_typing_show = False
            store.groupchat_who_typing = False

        if pic or audio:
            sends = 'status_picture' if pic else 'status_audio'
            time = time_to_send_pm if pic else time_to_send_am
            if who:
                store.groupchat_who_typing = who
                store.interlocutor_sends = sends
                renpy.pause(time, hard=True)
                store.interlocutor_sends = False
                store.groupchat_who_typing = False
            else:
                renpy.pause(time, hard=True)


        time_update()
        store.messages.append(Message(what, who, choices, audio, audio_bar, pic, pic_size, message_time))
        store.yadj.value = 9999*9999
        store.typewriter_counter = 0

        if status:
            store.interlocutor_online = False if status == 'offline' else interlocutor_online
        if in_history:
            add_history(who, what)
        if who:
            renpy.play(store.audio_path+'new_message'+store.audio_extension, 'audio')

        renpy.restart_interaction()
        if not click_to_continue:
            if who or not who and not typewriter:
                renpy.pause(1.0, hard=True)
            else:
                renpy.pause()
        else:
            renpy.pause()

        if choices:
            freeze()

    def get_previous_msg(all_msg, message):
        i = all_msg.index(message)+1
        if i >= 0 and i <= len(all_msg)-1:
            return all_msg[i]
        return False

    def find(what):
        temp = []
        if what == "":
            return temp
        for message in messages:
            # add usual message
            if message.what:
                if what.lower() in message.what.lower():
                    temp.append(message)
            else:
                # add pic
                if what == '#pic':
                    if message.pic:
                        temp.append(message)
                # add audio message
                elif what == '#audio':
                    if message.audio:
                        temp.append(message)         
        return temp

    input_find = ""
    def find_change_func(value):
        store.input_find = value
        store.yadj.value = 0
        renpy.restart_interaction()
    def find_reset():
        store.input_find = ""
        store.yadj.value = 9999*9999

    # Add message to history
    def add_history(who, what):
        if groupchat_enable and active_groupchat:
            who = active_groupchat.get_interlocutor(who).name if who != 0 else store.name
        else:
            who = store.interlocutor_name if who != 0 else store.name
        if what:
            store.narrator.add_history(kind='adv', who=who, what=what)
    
    # Message time update
    def time_update(m=1):
        if type(message_time) != bool:
            hours, minutes = message_time
            if minutes + m >= 60:
                hours += 1
                if hours >= 24:
                    hours = 0
                minutes += m-60
            else:
                minutes += m
            store.message_time = [hours, minutes]

    # Delete the last message
    def del_last_msg():
        if len(store.messages) > 0:
            del store.messages[-1]
    # Clear exluding the last message 
    def del_previous_msg():
        del store.messages[:-1]
    # Clear all messages
    def del_all_msg():
        store.messages = []
    # Choice logic
    def die_is_cast(lbl):
        unfreeze()
        del_last_msg()
        renpy.jump(lbl)
    # Status
    def online():
        store.interlocutor_online = True
    # Status
    def offline():
        store.interlocutor_online = False
    # Block Skip
    def freeze():
        renpy.config.skipping = False
        store._skipping = False
        renpy.pause(9999, hard=True)
    # Unblock Skip
    def unfreeze():
        store._skipping = True

    # Tag for message time
    def time_tag(tag, argument, contents):
        size = 38
        color = store.style_gray
        return [ (renpy.TEXT_TAG, u"size={}".format(size)), (renpy.TEXT_TAG, u"color={}".format(color)), 
            ] + contents + [ 
                (renpy.TEXT_TAG, u"/size"), (renpy.TEXT_TAG, u"/color"), ]
    config.custom_text_tags["t"] = time_tag
#################################################################################


#################################################################################
# Messenger Screen
#################################################################################
screen messenger():
    default find_enable = False
    key 'anykey' action NullAction()
    
    frame background None xysize (1080,1920):
        # Chat Icon / Interlocutor's Avatar
        $ avatar = active_groupchat.avatar if groupchat_enable and active_groupchat else 'messenger/av/'+interlocutor_name.lower().replace(' ', '_')+'.png'
        add avatar pos (111-6, 58-6)
        add 'messenger_background' pos -6,-6
        frame background None xysize (1000,1620) align (0.4,0.58):
            viewport id 'vp_msg' mousewheel True yadjustment yadj xsize 1080:
                vbox spacing 15 xsize 1000 box_reverse True:
                    $ all_messages = find(input_find) if find_enable else messages[::-1]
                    for message in all_messages:
                        $ you = not message.who
                        $ complete_message = typewriter_counter >= len(message.what) if message.what else True
                        $ can_type = you and typewriter and message == messages[-1] and not complete_message and not interlocutor_typing_show
                        $ box = 'box_one' if you else 'box_two'
                        $ box_hover = 'hover_box' if you else 'hover_box_two'
                        $ previous_message = get_previous_msg(all_messages, message)
                        $ interlocutor = active_groupchat.get_interlocutor(message.who) if groupchat_enable and not you else False
                        if interlocutor and previous_message:
                            $ interlocutor = False if previous_message.who == interlocutor.id else interlocutor
                        $ avatar_xoffset = not interlocutor and groupchat_enable
                        if message.audio: # Audio
                            default played = False
                            default audio_sec = 0
                            $ playing = renpy.music.get_playing(channel='sound')
                            $ current_audio = audio_sec if message.audio.name == playing else 0
                            $ now_play = message.audio.name == playing
                            $ audio_idle = 'stop_idle' if now_play else 'play_idle'
                            $ audio_hover = 'stop_hover' if now_play else 'play_hover'
                            $ xoffset = 1.08 if you and played and now_play else 0 # because of the viewport bug~
                            hbox spacing 5 xalign message.position:
                                if interlocutor: # Interlocutor's Avatar
                                    add interlocutor.avatar size 64,64 ypos 10
                                elif avatar_xoffset: # Avatar X Offset
                                    add 'empty' size 64,64
                                $ ysz = 99 if interlocutor else 0
                                $ yps = 60 if interlocutor else -6
                                $ ygn = .5 if interlocutor else .25
                                $ ydr = .6 if interlocutor else .95
                                frame background Frame(box, 25, 25) xalign message.position xysize 660,160+ysz:
                                    vbox spacing -100:
                                        $ gc = '{color=%s}%s\n{/color}'%(interlocutor.color, interlocutor.name) if interlocutor else False
                                        if gc:
                                            text gc style 'txt_base' xanchor 0.0 xpos 34 ypos 80     
                                        hbox spacing -250 xalign message.position-xoffset yalign 1.0:
                                            hbox spacing -100:
                                                button xysize 660,160+ysz pos (-6,yps) background audio_idle hover_background audio_hover action If (now_play, [Stop('sound')], [SetScreenVariable('played', True), SetScreenVariable('audio_sec', 0), Function(message.audio.play)]):
                                                    text "{k=1.5}%s{/k}"%(message.audio.duration) style 'txt_base' align .26,ydr xanchor 0.0 size 42 color style_gray
                                                if message_time:
                                                    text "{t}%s{/t}"%(message.time) style 'txt_time'
                                            if played and now_play:
                                                timer 0.05 repeat True action SetScreenVariable('audio_sec', audio_sec+0.05), If(audio_sec>=message.audio.length, [SetScreenVariable('audio_sec', 0), SetScreenVariable('played', False)])
                                            $ bar_xoffset = 10 if played and now_play else -240 # because of the viewport bug~
                                            bar value StaticValue(current_audio, message.audio.length) yalign ygn xpos bar_xoffset xysize (450, 69) thumb None left_bar message.audio.bar_hover() right_bar message.audio.bar_idle()
                        elif message.pic: # Picture
                            hbox spacing 5 xalign message.position:
                                if interlocutor: # Interlocutor's Avatar
                                    add interlocutor.avatar size 64,64 ypos 10
                                elif avatar_xoffset: # Avatar X Offset
                                    add 'empty' size 64,64
                                hbox spacing -100 xalign message.position:
                                    $ gc = '{color=%s}%s\n{/color} '%(interlocutor.color, interlocutor.name) if interlocutor else False
                                    $ bottom = 55 if message_time else 40
                                    $ top = 80 if interlocutor else 40
                                    button xalign message.position xmaximum 880 xpadding 0 top_padding top bottom_padding bottom background Frame(box, 25, 25) hover_background Frame(box_hover, 25,25) action Function(message.pic.open_fullpic):
                                        add 'messenger/pic/'+message.pic.name+'.jpg' align .5,.5 size message.pic.x, message.pic.y
                                    if message_time:
                                        text "{t}%s{/t}"%(message.time) style 'txt_time' yalign .99
                                    if gc:
                                        text gc style 'txt_base' xanchor 0.0 xpos -530 ypos 70

                        elif message.choices: # Menu
                            frame xalign message.position xmaximum 880 xpadding 20 ypadding 10 background Frame(box, 25, 25):
                                vbox:
                                    $ sort = sorted(message.choices.items(), key=lambda x: x)
                                    for k, v in sort:
                                        $ k = k+1
                                        $ txt = "%s"%(v.get('name', 'choice %s'%(k) )) # if not found - "choice 'number'"
                                        $ lbl = v.get('jump', 'start') # if not found - jump start
                                        $ t = "%s. %s"%(k, txt) if choice_number else "%s"%(txt)
                                        textbutton t hover_background '#22442D' action Function(die_is_cast, lbl) text_size 48 text_font style_font text_xalign 1.0 text_color '#fff' # clear screen - Function(del_all_msg)
                                        if choice_number:
                                            key str(k) action Function(die_is_cast, lbl)
                        else: # Usual message
                            $ hm = message.time
                            $ txt = message.what
                            if can_type: # Typewriter
                                $ hm = "" # do not show time in last message
                                $ txt = message.what[:typewriter_counter]
                            $ bottom = 50 if message_time else 35
                            $ gc = '{color=%s}%s\n{/color}'%(interlocutor.color, interlocutor.name) if interlocutor else ''
                            hbox spacing 5 xalign message.position:
                                if interlocutor: # Interlocutor's Avatar
                                    add interlocutor.avatar size 64,64 ypos 10
                                elif avatar_xoffset: # Avatar X Offset
                                    add 'empty' size 64,64
                                hbox spacing -100 xalign message.position:
                                    button xalign message.position xmaximum 880 xpadding 25 top_padding 25 bottom_padding bottom background Frame(box, 25, 25):
                                        text "%s%s"%(gc, txt) style 'txt_base'
                                    if message_time:
                                        text "{t}%s{/t}"%(hm) style 'txt_time'
                                    if can_type:
                                        key 'dismiss' action NullAction() # Block skip
                                        key 'anykey' action SetVariable('typewriter_counter', typewriter_counter+typewriter_speed)
    
        # Chat
        $ title_x = .22
        if groupchat_enable and active_groupchat:
            $ status = 'status_typing_groupchat' if interlocutor_typing_show else Text('%s members'%(active_groupchat.members), color=style_gray, style='txt_status')
            if status:
                $ status = 'status_picture_groupchat' if interlocutor_sends == 'status_picture' else 'status_audio_groupchat' if interlocutor_sends == 'status_audio' else status
            text "%s"%(active_groupchat.name) style 'txt_base' size 52 xalign title_x yalign 0.025 xanchor 0.0
            add status align title_x, 0.06 xanchor 0.0
        # Interlocutor's name & status
        else: 
            $ status = 'status_typing' if interlocutor_typing_show else 'status_online' if interlocutor_online else 'status_offline'
            $ status = interlocutor_sends if interlocutor_sends else status
            text "%s"%(interlocutor_name) style 'txt_base' size 52 xalign title_x yalign 0.025 xanchor 0.0
            add status align title_x, 0.06 xanchor 0.0
        
        # Arrow
        imagebutton idle 'arrow_idle' hover 'arrow_hover' align .01,.025 action NullAction()
        # Magnifier 
        $ magnifier_idle = 'magnifier_hover' if find_enable else 'magnifier_idle' 
        imagebutton idle magnifier_idle hover 'magnifier_hover' align .98,.025 action If(find_enable, [Function(find_reset), SetScreenVariable('find_enable', False)], SetScreenVariable('find_enable', True))
        
        if find_enable:
            input changed find_change_func length 14 align .12,.985 xanchor 0 color style_green size 48
            key 'K_ESCAPE' action Function(find_reset), SetScreenVariable('find_enable', False)

        # Telegram bar
        vbar value YScrollValue('vp_msg') style 'bar_vert'
#################################################################################
screen sc_fullpic(pic=False):
    modal True zorder 10
    add '#00000090' at blackout
    add 'messenger/pic/'+pic+'.jpg' at move_pic
    button background None action Hide('sc_fullpic')
#################################################################################

#################################################################################
# by sDextra 
#################################################################################
# 1110011 1000100 1100101 1111000 1110100 1110010 1100001
#################################################################################